package com.company.moduleb

import com.company.modulea.MaConfiguration
import io.jmix.core.annotation.JmixModule
import io.jmix.core.impl.scanning.AnnotationScanMetadataReaderFactory
import io.jmix.eclipselink.EclipselinkConfiguration
import io.jmix.flowui.FlowuiConfiguration
import io.jmix.flowui.sys.ActionsConfiguration
import io.jmix.flowui.sys.ViewControllersConfiguration
import org.springframework.boot.context.properties.ConfigurationPropertiesScan
import org.springframework.context.ApplicationContext
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.ComponentScan
import org.springframework.context.annotation.Configuration
import org.springframework.context.annotation.PropertySource

@Configuration
@ComponentScan
@ConfigurationPropertiesScan
@JmixModule(dependsOn = [EclipselinkConfiguration::class, FlowuiConfiguration::class, MaConfiguration::class])
@PropertySource(name = "com.company.moduleb", value = ["classpath:/com/company/moduleb/module.properties"])
open class MbConfiguration {

    @Bean("mb_MbViewControllers")
    open fun screens(applicationContext: ApplicationContext,
                     metadataReaderFactory: AnnotationScanMetadataReaderFactory
    ): ViewControllersConfiguration {
        return ViewControllersConfiguration(applicationContext, metadataReaderFactory).apply {
            basePackages = listOf("com.company.moduleb")
        }
    }

    @Bean("mb_MbActions")
    open fun actions(applicationContext: ApplicationContext,
                     metadataReaderFactory: AnnotationScanMetadataReaderFactory
    ): ActionsConfiguration {
        return ActionsConfiguration(applicationContext, metadataReaderFactory).apply {
            basePackages = listOf("com.company.moduleb")
        }
    }
}
