package com.company.moduled

import com.company.moduleb.MbConfiguration
import com.company.modulec.McConfiguration
import io.jmix.core.annotation.JmixModule
import io.jmix.core.impl.scanning.AnnotationScanMetadataReaderFactory
import io.jmix.eclipselink.EclipselinkConfiguration
import io.jmix.flowui.FlowuiConfiguration
import io.jmix.flowui.sys.ActionsConfiguration
import io.jmix.flowui.sys.ViewControllersConfiguration
import org.springframework.boot.context.properties.ConfigurationPropertiesScan
import org.springframework.context.ApplicationContext
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.ComponentScan
import org.springframework.context.annotation.Configuration
import org.springframework.context.annotation.PropertySource

@Configuration
@ComponentScan
@ConfigurationPropertiesScan
@JmixModule(dependsOn = [EclipselinkConfiguration::class, FlowuiConfiguration::class, MbConfiguration::class, McConfiguration::class])
@PropertySource(name = "com.company.moduled", value = ["classpath:/com/company/moduled/module.properties"])
open class MdConfiguration {

    @Bean("md_MdViewControllers")
    open fun screens(applicationContext: ApplicationContext,
                     metadataReaderFactory: AnnotationScanMetadataReaderFactory
    ): ViewControllersConfiguration {
        return ViewControllersConfiguration(applicationContext, metadataReaderFactory).apply {
            basePackages = listOf("com.company.moduled")
        }
    }

    @Bean("md_MdActions")
    open fun actions(applicationContext: ApplicationContext,
                     metadataReaderFactory: AnnotationScanMetadataReaderFactory
    ): ActionsConfiguration {
        return ActionsConfiguration(applicationContext, metadataReaderFactory).apply {
            basePackages = listOf("com.company.moduled")
        }
    }
}
